#!/bin/bash

###########################################################################
# Eole NG - 2007
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr
#
## script de gestion des filtres optionnels pour Amon
#
###########################################################################

## declaration des paths
squidGuardDb="/var/lib/blacklists/db"
squidGuardEole="/var/lib/blacklists/eole"
baseopt="/etc/squid/filtres-opt"
modifopt="/etc/squid/filtres-users"

# 1. on supprime tout
[ -e $baseopt ] && {
	for i in `cat $baseopt | awk -F#  '{ print $1 }'`;
	do
		# pas de "/" final pour les liens
		rm -rf $squidGuardDb/$i
	done
}

# 2. liens sur les filtes activés
[ -e $modifopt ] && {
	echo "activation des filtres optionnels"
	for i in `cat $modifopt`; 
	do
		if [ -e $squidGuardEole/$i ]
		then
			ln -s  $squidGuardEole/$i $squidGuardDb/$i
			if [ ! -e $squidGuardEole/$i/urls ]
			then
				# ajout du fichiers url si absent
				touch $squidGuardEole/$i/urls
			fi
		fi
	done
}

# 3. bases vide dans les autres cas
for i in `cat $baseopt | awk -F#  '{ print $1 }'`;
do
	if [ ! -d $squidGuardDb/$i ]
	then
		mkdir -p $squidGuardDb/$i
		touch $squidGuardDb/$i/domains
		touch $squidGuardDb/$i/urls
	fi
done

