#!/bin/bash
##################################################
# gen_certifEole
# generation du certificat pour apache (Ead)
# realise par samuel morin <samuel.morin@ac-dijon.fr>
# $Id: gen_certifEole.sh,v 1.1.1.1 2004/01/05 10:16:50 eole Exp $
###################################################

# Appel Bibliothèque
. ParseDico

# Création intéractive d'une demande PKCS#10 décorée par un SubjectAltName.
# Le format de fichier de sortie est le suivant :
#
# SubjectAltName=fw-ecole-beaune.eole.ac-dijon.fr
# --- BEGIN PKCS#10 ---
# mldjmldfgjsmldfgjsdlmjgsdm
# --- END PKCS#10 ---
PATHAPACHE2=/etc/apache2/ssl/
REQUETEOUT=$PATHAPACHE2/server.crt
REQUETECONF=/usr/share/eole/certif-eole.conf

mkdir -p $PATHAPACHE2
echo "SubjectAltName=$mon_machine.$nom_domaine_local" > $REQUETEOUT

openssl req -x509 -new -newkey rsa:1024 -days 1825 -config $REQUETECONF -out $REQUETEOUT.tmp && cat $REQUETEOUT.tmp >> $REQUETEOUT

rm $REQUETEOUT.tmp

cp $PATHAPACHE2/server.key /tmp/key

openssl rsa -in /tmp/key -passin pass:secret -out $PATHAPACHE2/server.key

rm -f /tmp/key

chmod 400 $PATHAPACHE2/server.key
